Index: xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxpict.c
===================================================================
--- xorg-server-7.2.0.0-1.5.99.1.orig/hw/dmx/dmxpict.c
+++ xorg-server-7.2.0.0-1.5.99.1/hw/dmx/dmxpict.c
@@ -64,27 +64,113 @@ static int (*dmxSaveRenderVector[RenderN
 
 
 static int dmxProcRenderCreateGlyphSet(ClientPtr client);
-static int dmxProcRenderFreeGlyphSet(ClientPtr client);
+static int dmxProcRenderReferenceGlyphSet(ClientPtr client);
 static int dmxProcRenderAddGlyphs(ClientPtr client);
 static int dmxProcRenderFreeGlyphs(ClientPtr client);
 static int dmxProcRenderCompositeGlyphs(ClientPtr client);
 static int dmxProcRenderSetPictureTransform(ClientPtr client);
 static int dmxProcRenderSetPictureFilter(ClientPtr client);
+static int dmxProcRenderChangePicture (ClientPtr client);
 #if 0
 /* FIXME: Not (yet) supported */
 static int dmxProcRenderCreateCursor(ClientPtr client);
 static int dmxProcRenderCreateAnimCursor(ClientPtr client);
 #endif
+static int dmxProcRenderCreateSolidFill (ClientPtr pClient);
+static int dmxProcRenderCreateLinearGradient (ClientPtr pClient);
+static int dmxProcRenderCreateRadialGradient (ClientPtr pClient);
+static int dmxProcRenderCreateConicalGradient (ClientPtr pClient);
 
-/** Catch errors that might occur when allocating Glyph Sets.  Errors
- *  are saved in dmxGlyphLastError for later handling. */
-static int dmxGlyphLastError;
-static int dmxGlyphErrorHandler(Display *dpy, XErrorEvent *ev)
+unsigned long DMX_GLYPHSET;
+unsigned long DMX_SOURCEPICT;
+
+static int
+dmxFreeGlyphSet (pointer value,
+		 XID     gid)
 {
-    dmxGlyphLastError = ev->error_code;
-    return 0;
+    GlyphSetPtr	glyphSet = (GlyphSetPtr) value;
+
+    if (glyphSet->refcnt <= 2) {
+	dmxGlyphPrivPtr  glyphPriv = DMX_GET_GLYPH_PRIV(glyphSet);
+	int              i;
+
+	for (i = 0; i < dmxNumScreens; i++) {
+	    DMXScreenInfo *dmxScreen = &dmxScreens[i];
+
+	    if (dmxScreen->beDisplay) {
+		if (dmxBEFreeGlyphSet(screenInfo.screens[i], glyphSet))
+		    dmxSync(dmxScreen, FALSE);
+	    }
+	}
+
+        MAXSCREENSFREE(glyphPriv->glyphSets);
+    }
+
+    return FreeGlyphSet (value, gid);
+}
+
+static int
+dmxFreeSourcePict (pointer value,
+		   XID     gid)
+{
+    PicturePtr pPicture = (PicturePtr) value;
+
+    if (pPicture->refcnt <= 2) {
+	dmxPictPrivPtr pPictPriv = DMX_GET_PICT_PRIV(pPicture);
+	int            i;
+
+	for (i = 0; i < dmxNumScreens; i++) {
+	    DMXScreenInfo *dmxScreen = &dmxScreens[i];
+
+	    if (dmxScreen->beDisplay)
+		dmxBEFreePicture (screenInfo.screens[i], pPicture);
+	}
+
+        MAXSCREENSFREE(pPictPriv->sourcePict);
+    }
+
+    return FreePicture (value, gid);
+}
+
+static Bool
+dmxRealizeGlyph (ScreenPtr pScreen,
+		 GlyphPtr  glyph)
+{
+    PictureScreenPtr ps  = GetPictureScreen (pScreen);
+    DMXScreenInfo    *dmxScreen = &dmxScreens[pScreen->myNum];
+    int              ret;
+
+    if (pScreen->myNum == 0)
+	*((PrivateRec **) dixLookupPrivateAddr (&(glyph)->devPrivates,
+						dmxGlyphPrivateKey)) = NULL;
+
+    DMX_UNWRAP (RealizeGlyph, dmxScreen, ps);
+    ret = (*ps->RealizeGlyph) (pScreen, glyph);
+    DMX_WRAP (RealizeGlyph, dmxRealizeGlyph, dmxScreen, ps);
+
+    return ret;
 }
 
+static void
+dmxUnrealizeGlyph (ScreenPtr pScreen,
+		   GlyphPtr  glyph)
+{
+    PictureScreenPtr ps = GetPictureScreen (pScreen);
+    DMXScreenInfo    *dmxScreen = &dmxScreens[pScreen->myNum];
+
+    if (pScreen->myNum == 0)
+    {
+	char *data;
+
+	data = dixLookupPrivate (&(glyph)->devPrivates, dmxGlyphPrivateKey);
+	if (data)
+	    xfree (data);
+    }
+
+    DMX_UNWRAP (UnrealizeGlyph, dmxScreen, ps);
+    (*ps->UnrealizeGlyph) (pScreen, glyph);
+    DMX_WRAP (UnrealizeGlyph, dmxUnrealizeGlyph, dmxScreen, ps);
+}
 
 /** Initialize the Proc Vector for the RENDER extension.  The functions
  *  here cannot be handled by the mi layer RENDER hooks either because
@@ -96,13 +182,16 @@ void dmxInitRender(void)
 {
     int i;
 
+    DMX_GLYPHSET = CreateNewResourceType (dmxFreeGlyphSet);
+    DMX_SOURCEPICT = CreateNewResourceType (dmxFreeSourcePict);
+
     for (i = 0; i < RenderNumberRequests; i++)
         dmxSaveRenderVector[i] = ProcRenderVector[i];
 
     ProcRenderVector[X_RenderCreateGlyphSet]
 	= dmxProcRenderCreateGlyphSet;
-    ProcRenderVector[X_RenderFreeGlyphSet]
-	= dmxProcRenderFreeGlyphSet;
+    ProcRenderVector[X_RenderReferenceGlyphSet]
+	= dmxProcRenderReferenceGlyphSet;
     ProcRenderVector[X_RenderAddGlyphs]
 	= dmxProcRenderAddGlyphs;
     ProcRenderVector[X_RenderFreeGlyphs]
@@ -117,6 +206,16 @@ void dmxInitRender(void)
 	= dmxProcRenderSetPictureTransform;
     ProcRenderVector[X_RenderSetPictureFilter]
 	= dmxProcRenderSetPictureFilter;
+    ProcRenderVector[X_RenderChangePicture]
+	= dmxProcRenderChangePicture;
+    ProcRenderVector[X_RenderCreateSolidFill] =
+	dmxProcRenderCreateSolidFill;
+    ProcRenderVector[X_RenderCreateLinearGradient] =
+	dmxProcRenderCreateLinearGradient;
+    ProcRenderVector[X_RenderCreateRadialGradient] =
+	dmxProcRenderCreateRadialGradient;
+    ProcRenderVector[X_RenderCreateConicalGradient] =
+	dmxProcRenderCreateConicalGradient;
 }
 
 /** Reset the Proc Vector for the RENDER extension back to the original
@@ -130,6 +229,245 @@ void dmxResetRender(void)
         ProcRenderVector[i] = dmxSaveRenderVector[i];
 }
 
+static int
+dmxVisualDepth (ScreenPtr pScreen, VisualPtr pVisual)
+{
+    DepthPtr pDepth;
+    int	     d, v;
+
+    for (d = 0; d < pScreen->numDepths; d++)
+    {
+	pDepth = &pScreen->allowedDepths[d];
+	for (v = 0; v < pDepth->numVids; v++)
+	    if (pDepth->vids[v] == pVisual->vid)
+		return pDepth->depth;
+    }
+
+    return 0;
+}
+
+typedef struct _dmxformatInit {
+    CARD32 format;
+    CARD8  depth;
+} dmxFormatInitRec, *dmxFormatInitPtr;
+
+static int
+dmxAddFormat (dmxFormatInitPtr formats,
+	      int	       nformat,
+	      CARD32	       format,
+	      CARD8	       depth)
+{
+    int	n;
+
+    for (n = 0; n < nformat; n++)
+	if (formats[n].format == format && formats[n].depth == depth)
+	    return nformat;
+
+    formats[nformat].format = format;
+    formats[nformat].depth = depth;
+
+    return ++nformat;
+}
+
+#define Mask(n)	((n) == 32 ? 0xffffffff : ((1 << (n)) - 1))
+
+static PictFormatPtr
+dmxCreateDefaultFormats (ScreenPtr pScreen, int *nformatp)
+{
+    int		     f, nformats = 0;
+    PictFormatPtr    pFormats;
+    dmxFormatInitRec formats[64];
+    CARD32	     format;
+    CARD8	     depth;
+    VisualPtr	     pVisual;
+    int		     v;
+    int		     bpp;
+    int		     r, g, b;
+    int		     d;
+    DepthPtr	     pDepth;
+
+    /* formats required by protocol */
+    formats[nformats].format = PICT_a1;
+    formats[nformats].depth = 1;
+    nformats++;
+    formats[nformats].format = PICT_a4;
+    formats[nformats].depth = 4;
+    nformats++;
+    formats[nformats].format = PICT_a8;
+    formats[nformats].depth = 8;
+    nformats++;
+    formats[nformats].format = PICT_a8r8g8b8;
+    formats[nformats].depth = 32;
+    nformats++;
+
+    /* now look through the depths and visuals adding other formats */
+    for (v = 0; v < pScreen->numVisuals; v++)
+    {
+	pVisual = &pScreen->visuals[v];
+	depth = dmxVisualDepth (pScreen, pVisual);
+	if (!depth || depth == 32)
+	    continue;
+
+	bpp = BitsPerPixel (depth);
+	switch (pVisual->class) {
+	case DirectColor:
+	case TrueColor:
+	    r = Ones (pVisual->redMask);
+	    g = Ones (pVisual->greenMask);
+	    b = Ones (pVisual->blueMask);
+	    if (pVisual->offsetBlue == 0 &&
+		pVisual->offsetGreen == b &&
+		pVisual->offsetRed == b + g)
+	    {
+		format = PICT_FORMAT (bpp, PICT_TYPE_ARGB, 0, r, g, b);
+		nformats = dmxAddFormat (formats, nformats, format, depth);
+	    }
+	    break;
+	case StaticColor:
+	case PseudoColor:
+	case StaticGray:
+	case GrayScale:
+	    break;
+	}
+    }
+
+    /*
+     * Walk supported depths and add useful Direct formats
+     */
+    for (d = 0; d < 0; d++)
+    {
+	pDepth = &pScreen->allowedDepths[d];
+	bpp = BitsPerPixel (pDepth->depth);
+	format = 0;
+	switch (bpp) {
+	case 16:
+	    /* depth 12 formats */
+	    if (pDepth->depth >= 12)
+	    {
+		nformats = dmxAddFormat (formats, nformats,
+					 PICT_x4r4g4b4, pDepth->depth);
+		nformats = dmxAddFormat (formats, nformats,
+					 PICT_x4b4g4r4, pDepth->depth);
+	    }
+	    /* depth 15 formats */
+	    if (pDepth->depth >= 15)
+	    {
+		nformats = dmxAddFormat (formats, nformats,
+					 PICT_x1r5g5b5, pDepth->depth);
+		nformats = dmxAddFormat (formats, nformats,
+					 PICT_x1b5g5r5, pDepth->depth);
+	    }
+	    /* depth 16 formats */
+	    if (pDepth->depth >= 16)
+	    {
+		nformats = dmxAddFormat (formats, nformats,
+					 PICT_a1r5g5b5, pDepth->depth);
+		nformats = dmxAddFormat (formats, nformats,
+					 PICT_a1b5g5r5, pDepth->depth);
+		nformats = dmxAddFormat (formats, nformats,
+					 PICT_r5g6b5, pDepth->depth);
+		nformats = dmxAddFormat (formats, nformats,
+					 PICT_b5g6r5, pDepth->depth);
+		nformats = dmxAddFormat (formats, nformats,
+					 PICT_a4r4g4b4, pDepth->depth);
+		nformats = dmxAddFormat (formats, nformats,
+					 PICT_a4b4g4r4, pDepth->depth);
+	    }
+	    break;
+	case 24:
+	    if (pDepth->depth >= 24)
+	    {
+		nformats = dmxAddFormat (formats, nformats,
+					 PICT_r8g8b8, pDepth->depth);
+		nformats = dmxAddFormat (formats, nformats,
+					 PICT_b8g8r8, pDepth->depth);
+	    }
+	    break;
+	case 32:
+	    if (pDepth->depth >= 24)
+	    {
+		nformats = dmxAddFormat (formats, nformats,
+					 PICT_x8r8g8b8, pDepth->depth);
+		nformats = dmxAddFormat (formats, nformats,
+					 PICT_x8b8g8r8, pDepth->depth);
+	    }
+	    break;
+	}
+    }
+
+
+    pFormats = (PictFormatPtr) xalloc (nformats * sizeof (PictFormatRec));
+    if (!pFormats)
+	return 0;
+    memset (pFormats, '\0', nformats * sizeof (PictFormatRec));
+    for (f = 0; f < nformats; f++)
+    {
+        pFormats[f].id = FakeClientID (0);
+	pFormats[f].depth = formats[f].depth;
+	format = formats[f].format;
+	pFormats[f].format = format;
+	switch (PICT_FORMAT_TYPE(format)) {
+	case PICT_TYPE_ARGB:
+	    pFormats[f].type = PictTypeDirect;
+
+	    pFormats[f].direct.alphaMask = Mask(PICT_FORMAT_A(format));
+	    if (pFormats[f].direct.alphaMask)
+		pFormats[f].direct.alpha = (PICT_FORMAT_R(format) +
+					    PICT_FORMAT_G(format) +
+					    PICT_FORMAT_B(format));
+
+	    pFormats[f].direct.redMask = Mask(PICT_FORMAT_R(format));
+	    pFormats[f].direct.red = (PICT_FORMAT_G(format) +
+				      PICT_FORMAT_B(format));
+
+	    pFormats[f].direct.greenMask = Mask(PICT_FORMAT_G(format));
+	    pFormats[f].direct.green = PICT_FORMAT_B(format);
+
+	    pFormats[f].direct.blueMask = Mask(PICT_FORMAT_B(format));
+	    pFormats[f].direct.blue = 0;
+	    break;
+
+	case PICT_TYPE_ABGR:
+	    pFormats[f].type = PictTypeDirect;
+
+	    pFormats[f].direct.alphaMask = Mask(PICT_FORMAT_A(format));
+	    if (pFormats[f].direct.alphaMask)
+		pFormats[f].direct.alpha = (PICT_FORMAT_B(format) +
+					    PICT_FORMAT_G(format) +
+					    PICT_FORMAT_R(format));
+
+	    pFormats[f].direct.blueMask = Mask(PICT_FORMAT_B(format));
+	    pFormats[f].direct.blue = (PICT_FORMAT_G(format) +
+				       PICT_FORMAT_R(format));
+
+	    pFormats[f].direct.greenMask = Mask(PICT_FORMAT_G(format));
+	    pFormats[f].direct.green = PICT_FORMAT_R(format);
+
+	    pFormats[f].direct.redMask = Mask(PICT_FORMAT_R(format));
+	    pFormats[f].direct.red = 0;
+	    break;
+
+	case PICT_TYPE_A:
+	    pFormats[f].type = PictTypeDirect;
+
+	    pFormats[f].direct.alpha = 0;
+	    pFormats[f].direct.alphaMask = Mask(PICT_FORMAT_A(format));
+
+	    /* remaining fields already set to zero */
+	    break;
+
+	case PICT_TYPE_COLOR:
+	case PICT_TYPE_GRAY:
+	    pFormats[f].type = PictTypeIndexed;
+	    pFormats[f].index.vid = pScreen->visuals[PICT_FORMAT_VIS(format)].vid;
+	    break;
+	}
+    }
+
+    *nformatp = nformats;
+    return pFormats;
+}
+
 /** Initialize the RENDER extension, allocate the picture privates and
  *  wrap mi function hooks.  If the shadow frame buffer is used, then
  *  call the appropriate fb initialization function. */
@@ -138,8 +476,12 @@ Bool dmxPictureInit(ScreenPtr pScreen, P
     DMXScreenInfo    *dmxScreen = &dmxScreens[pScreen->myNum];
     PictureScreenPtr  ps;
 
-    /* The shadow framebuffer only relies on FB to be initialized */
-    if (dmxShadowFB) return fbPictureInit(pScreen, formats, nformats);
+    if (!formats)
+    {
+	formats = dmxCreateDefaultFormats (pScreen, &nformats);
+	if (!formats)
+	    return FALSE;
+    }
 
     if (!miPictureInit(pScreen, formats, nformats))
 	return FALSE;
@@ -147,6 +489,12 @@ Bool dmxPictureInit(ScreenPtr pScreen, P
     if (!dixRequestPrivate(dmxPictPrivateKey, sizeof(dmxPictPrivRec)))
 	return FALSE;
 
+    if (!dixRequestPrivate(dmxGlyphSetPrivateKey, sizeof(dmxGlyphPrivRec)))
+	return FALSE;
+
+    if (!dixRequestPrivate(dmxGlyphPrivateKey, 0))
+	return FALSE;
+
     ps = GetPictureScreen(pScreen);
 
     DMX_WRAP(CreatePicture,      dmxCreatePicture,      dmxScreen, ps);
@@ -167,6 +515,9 @@ Bool dmxPictureInit(ScreenPtr pScreen, P
     DMX_WRAP(TriStrip,           dmxTriStrip,           dmxScreen, ps);
     DMX_WRAP(TriFan,             dmxTriFan,             dmxScreen, ps);
 
+    DMX_WRAP(RealizeGlyph,       dmxRealizeGlyph,       dmxScreen, ps);
+    DMX_WRAP(UnrealizeGlyph,     dmxUnrealizeGlyph,     dmxScreen, ps);
+
     return TRUE;
 }
 
@@ -184,7 +535,10 @@ static XRenderPictFormat *dmxFindFormat(
     if (!pFmt || !dmxScreen->beDisplay) return pFormat;
 
     while (1) {
+	pFormat = NULL;
+	XLIB_PROLOGUE (dmxScreen);
 	pFormat = XRenderFindFormat(dmxScreen->beDisplay, 0, 0, i++);
+	XLIB_EPILOGUE (dmxScreen);
 	if (!pFormat) break;
 
 	if (pFormat->type             != pFmt->type)             continue;
@@ -213,7 +567,9 @@ Bool dmxBEFreeGlyphSet(ScreenPtr pScreen
     DMXScreenInfo   *dmxScreen = &dmxScreens[idx];
 
     if (glyphPriv->glyphSets[idx]) {
+	XLIB_PROLOGUE (dmxScreen);
 	XRenderFreeGlyphSet(dmxScreen->beDisplay, glyphPriv->glyphSets[idx]);
+	XLIB_EPILOGUE (dmxScreen);
 	glyphPriv->glyphSets[idx] = (GlyphSet)0;
 	return TRUE;
     }
@@ -228,25 +584,19 @@ int dmxBECreateGlyphSet(int idx, GlyphSe
     DMXScreenInfo     *dmxScreen = &dmxScreens[idx];
     dmxGlyphPrivPtr    glyphPriv = DMX_GET_GLYPH_PRIV(glyphSet);
     PictFormatPtr      pFmt      = glyphSet->format;
-    int              (*oldErrorHandler)(Display *, XErrorEvent *);
 
     pFormat = dmxFindFormat(dmxScreen, pFmt);
     if (!pFormat) {
 	return BadMatch;
     }
 
-    dmxGlyphLastError = 0;
-    oldErrorHandler = XSetErrorHandler(dmxGlyphErrorHandler);
+    glyphPriv->glyphSets[idx] = None;
 
     /* Catch when this fails */
+    XLIB_PROLOGUE (dmxScreen);
     glyphPriv->glyphSets[idx]
 	= XRenderCreateGlyphSet(dmxScreen->beDisplay, pFormat);
-
-    XSetErrorHandler(oldErrorHandler);
-
-    if (dmxGlyphLastError) {
-	return dmxGlyphLastError;
-    }
+    XLIB_EPILOGUE (dmxScreen);
 
     return Success;
 }
@@ -273,68 +623,46 @@ static int dmxProcRenderCreateGlyphSet(C
 	
 	glyphSet = SecurityLookupIDByType(client, stuff->gsid, GlyphSetType,
 					  DixDestroyAccess);
-	glyphPriv = xalloc(sizeof(dmxGlyphPrivRec));
-	if (!glyphPriv) return BadAlloc;
+	glyphPriv = DMX_GET_GLYPH_PRIV(glyphSet);
         glyphPriv->glyphSets = NULL;
         MAXSCREENSALLOC_RETURN(glyphPriv->glyphSets, BadAlloc);
-	DMX_SET_GLYPH_PRIV(glyphSet, glyphPriv);
+	memset (glyphPriv->glyphSets, 0,
+		sizeof (*glyphPriv->glyphSets) * MAXSCREENS);
+	glyphSet->refcnt++;
+	AddResource (stuff->gsid, DMX_GLYPHSET, glyphSet);
 
 	for (i = 0; i < dmxNumScreens; i++) {
 	    DMXScreenInfo *dmxScreen = &dmxScreens[i];
-	    int beret;
 
-	    if (!dmxScreen->beDisplay) {
-		glyphPriv->glyphSets[i] = 0;
+	    if (!dmxScreen->beDisplay)
 		continue;
-	    }
-
-	    if ((beret = dmxBECreateGlyphSet(i, glyphSet)) != Success) {
-		int  j;
-
-		/* Free the glyph sets we've allocated thus far */
-		for (j = 0; j < i; j++)
-		    dmxBEFreeGlyphSet(screenInfo.screens[j], glyphSet);
-
-		/* Free the resource created by render */
-		FreeResource(stuff->gsid, RT_NONE);
 
-		return beret;
-	    }
+	    dmxBECreateGlyphSet (i, glyphSet);
+	    dmxSync (dmxScreen, FALSE);
 	}
     }
 
     return ret;
 }
 
-/** Free the previously allocated Glyph Sets for each screen. */
-static int dmxProcRenderFreeGlyphSet(ClientPtr client)
+static int dmxProcRenderReferenceGlyphSet (ClientPtr client)
 {
-    GlyphSetPtr  glyphSet;
-    REQUEST(xRenderFreeGlyphSetReq);
-
-    REQUEST_SIZE_MATCH(xRenderFreeGlyphSetReq);
-    glyphSet = SecurityLookupIDByType(client, stuff->glyphset, GlyphSetType,
-				      DixDestroyAccess);
-
-    if (glyphSet && glyphSet->refcnt == 1) {
-	dmxGlyphPrivPtr  glyphPriv = DMX_GET_GLYPH_PRIV(glyphSet);
-	int              i;
+    int ret;
+    REQUEST(xRenderReferenceGlyphSetReq);
 
-	for (i = 0; i < dmxNumScreens; i++) {
-	    DMXScreenInfo *dmxScreen = &dmxScreens[i];
-	    
-	    if (dmxScreen->beDisplay) {
-		if (dmxBEFreeGlyphSet(screenInfo.screens[i], glyphSet))
-		    dmxSync(dmxScreen, FALSE);
-	    }
-	}
+    ret = dmxSaveRenderVector[stuff->renderReqType](client);
 
-        MAXSCREENSFREE(glyphPriv->glyphSets);
-	xfree(glyphPriv);
-	DMX_SET_GLYPH_PRIV(glyphSet, NULL);
+    if (ret == Success)
+    {
+	GlyphSetPtr glyphSet;
+
+	glyphSet = SecurityLookupIDByType (client, stuff->gsid, GlyphSetType,
+					   DixDestroyAccess);
+	glyphSet->refcnt++;
+	AddResource (stuff->gsid, DMX_GLYPHSET, glyphSet);
     }
 
-    return dmxSaveRenderVector[stuff->renderReqType](client);
+    return ret;
 }
 
 /** Add glyphs to the Glyph Set on each screen. */
@@ -354,7 +682,8 @@ static int dmxProcRenderAddGlyphs(Client
 	Glyph           *gidsCopy;
 	xGlyphInfo      *gi;
 	CARD8           *bits;
-	int              nbytes;
+	int              nbytes, size;
+	void		*data;
 
 	glyphSet = SecurityLookupIDByType(client, stuff->glyphset,
 					  GlyphSetType, DixReadAccess);
@@ -369,13 +698,42 @@ static int dmxProcRenderAddGlyphs(Client
 		  (sizeof(CARD32) + sizeof(xGlyphInfo)) * nglyphs);
 
         gidsCopy = xalloc(sizeof(*gidsCopy) * nglyphs);
-        for (i = 0; i < nglyphs; i++) gidsCopy[i] = gids[i];
+        for (i = 0; i < nglyphs; i++)
+	{
+	    GlyphPtr glyph;
+
+	    gidsCopy[i] = gids[i];
+
+	    size = gi[i].height * PixmapBytePad (gi[i].width,
+						 glyphSet->format->depth);
+	    if (size & 3)
+		size += 4 - (size & 3);
+
+	    glyph = FindGlyph (glyphSet, gids[i]);
+	    if (glyph)
+	    {
+		data = xalloc (size);
+		if (data)
+		{
+		    memcpy (data, bits, size);
+		    *((PrivateRec **)
+		      dixLookupPrivateAddr (&(glyph)->devPrivates,
+					    dmxGlyphPrivateKey)) = data;
+		}
+	    }
+
+	    bits += size;
+	}
+
+	bits = (CARD8 *)(gi + nglyphs);
 
 	/* FIXME: Will this ever fail? */
 	for (i = 0; i < dmxNumScreens; i++) {
 	    DMXScreenInfo *dmxScreen = &dmxScreens[i];
 
 	    if (dmxScreen->beDisplay) {
+
+		XLIB_PROLOGUE (dmxScreen);
 		XRenderAddGlyphs(dmxScreen->beDisplay,
 				 glyphPriv->glyphSets[i],
 				 gidsCopy,
@@ -383,6 +741,7 @@ static int dmxProcRenderAddGlyphs(Client
 				 nglyphs,
 				 (char *)bits,
 				 nbytes);
+		XLIB_EPILOGUE (dmxScreen);
 		dmxSync(dmxScreen, FALSE);
 	    }
 	}
@@ -418,8 +777,10 @@ static int dmxProcRenderFreeGlyphs(Clien
 		DMXScreenInfo *dmxScreen = &dmxScreens[i];
 
 		if (dmxScreen->beDisplay) {
+		    XLIB_PROLOGUE (dmxScreen);
 		    XRenderFreeGlyphs(dmxScreen->beDisplay,
 				      glyphPriv->glyphSets[i], gids, nglyphs);
+		    XLIB_EPILOGUE (dmxScreen);
 		    dmxSync(dmxScreen, FALSE);
 		}
 	    }
@@ -471,11 +832,7 @@ static int dmxProcRenderCompositeGlyphs(
 	GlyphSetPtr        glyphSet;
 	dmxGlyphPrivPtr    glyphPriv;
 
-	pSrc = SecurityLookupIDByType(client, stuff->src, PictureType,
-				      DixReadAccess);
-	pSrcPriv = DMX_GET_PICT_PRIV(pSrc);
-	if (!pSrcPriv->pict)
-	    return ret;
+	Picture	           src = None;
 
 	pDst = SecurityLookupIDByType(client, stuff->dst, PictureType,
 				      DixWriteAccess);
@@ -486,6 +843,18 @@ static int dmxProcRenderCompositeGlyphs(
 	scrnNum = pDst->pDrawable->pScreen->myNum;
 	dmxScreen = &dmxScreens[scrnNum];
 
+	pSrc = SecurityLookupIDByType(client, stuff->src, PictureType,
+				      DixReadAccess);
+	pSrcPriv = DMX_GET_PICT_PRIV(pSrc);
+
+	if (pSrc->pDrawable)
+	    src = pSrcPriv->pict;
+	else
+	    src = pSrcPriv->sourcePict[scrnNum];
+
+	if (!src)
+	    return ret;
+
 	/* Note: If the back-end display has been detached, then it
 	 * should not be possible to reach here since the pSrcPriv->pict
 	 * and pDstPriv->pict will have already been set to 0.
@@ -578,30 +947,34 @@ static int dmxProcRenderCompositeGlyphs(
 	    }
 	}
 
+	XLIB_PROLOGUE (dmxScreen);
+
 	switch (stuff->renderReqType) {
 	case X_RenderCompositeGlyphs8:
 	    XRenderCompositeText8(dmxScreen->beDisplay, stuff->op,
-				  pSrcPriv->pict, pDstPriv->pict,
+				  src, pDstPriv->pict,
 				  pFormat,
 				  stuff->xSrc, stuff->ySrc,
 				  0, 0, elts, nelt);
 	    break;
 	case X_RenderCompositeGlyphs16:
 	    XRenderCompositeText16(dmxScreen->beDisplay, stuff->op,
-				   pSrcPriv->pict, pDstPriv->pict,
+				   src, pDstPriv->pict,
 				   pFormat,
 				   stuff->xSrc, stuff->ySrc,
 				   0, 0, (XGlyphElt16 *)elts, nelt);
 	    break;
 	case X_RenderCompositeGlyphs32:
 	    XRenderCompositeText32(dmxScreen->beDisplay, stuff->op,
-				   pSrcPriv->pict, pDstPriv->pict,
+				   src, pDstPriv->pict,
 				   pFormat,
 				   stuff->xSrc, stuff->ySrc,
 				   0, 0, (XGlyphElt32 *)elts, nelt);
 	    break;
 	}
 
+	XLIB_EPILOGUE (dmxScreen);
+
 	dmxSync(dmxScreen, FALSE);
 
 	xfree(elts);
@@ -624,27 +997,49 @@ static int dmxProcRenderSetPictureTransf
     VERIFY_PICTURE(pPicture, stuff->picture, client, DixWriteAccess,
 		   RenderErrBase + BadPicture);
 
+    pPictPriv = DMX_GET_PICT_PRIV(pPicture);
+
+    xform.matrix[0][0] = stuff->transform.matrix11;
+    xform.matrix[0][1] = stuff->transform.matrix12;
+    xform.matrix[0][2] = stuff->transform.matrix13;
+    xform.matrix[1][0] = stuff->transform.matrix21;
+    xform.matrix[1][1] = stuff->transform.matrix22;
+    xform.matrix[1][2] = stuff->transform.matrix23;
+    xform.matrix[2][0] = stuff->transform.matrix31;
+    xform.matrix[2][1] = stuff->transform.matrix32;
+    xform.matrix[2][2] = stuff->transform.matrix33;
+
     /* For the following to work with PanoramiX, it assumes that Render
      * wraps the ProcRenderVector after dmxRenderInit has been called.
      */
-    dmxScreen = &dmxScreens[pPicture->pDrawable->pScreen->myNum];
-    pPictPriv = DMX_GET_PICT_PRIV(pPicture);
+    if (pPicture->pDrawable)
+    {
+	dmxScreen = &dmxScreens[pPicture->pDrawable->pScreen->myNum];
+
+	if (pPictPriv->pict) {
+	    XLIB_PROLOGUE (dmxScreen);
+	    XRenderSetPictureTransform(dmxScreen->beDisplay,
+				       pPictPriv->pict,
+				       &xform);
+	    XLIB_EPILOGUE (dmxScreen);
+	}
+    }
+    else if (pPictPriv->sourcePict)
+    {
+	int i;
 
-    if (pPictPriv->pict) {
-	xform.matrix[0][0] = stuff->transform.matrix11;
-	xform.matrix[0][1] = stuff->transform.matrix12;
-	xform.matrix[0][2] = stuff->transform.matrix13;
-	xform.matrix[1][0] = stuff->transform.matrix21;
-	xform.matrix[1][1] = stuff->transform.matrix22;
-	xform.matrix[1][2] = stuff->transform.matrix23;
-	xform.matrix[2][0] = stuff->transform.matrix31;
-	xform.matrix[2][1] = stuff->transform.matrix32;
-	xform.matrix[2][2] = stuff->transform.matrix33;
-
-	XRenderSetPictureTransform(dmxScreen->beDisplay,
-				   pPictPriv->pict,
-				   &xform);
-	dmxSync(dmxScreen, FALSE);
+	for (i = 0; i < dmxNumScreens; i++) {
+	    DMXScreenInfo *dmxScreen = &dmxScreens[i];
+
+	    if (pPictPriv->sourcePict[i])
+	    {
+		XLIB_PROLOGUE (dmxScreen);
+		XRenderSetPictureTransform(dmxScreen->beDisplay,
+					   pPictPriv->sourcePict[i],
+					   &xform);
+		XLIB_EPILOGUE (dmxScreen);
+	    }
+	}
     }
 
     return dmxSaveRenderVector[stuff->renderReqType](client);
@@ -668,25 +1063,267 @@ static int dmxProcRenderSetPictureFilter
     /* For the following to work with PanoramiX, it assumes that Render
      * wraps the ProcRenderVector after dmxRenderInit has been called.
      */
-    dmxScreen = &dmxScreens[pPicture->pDrawable->pScreen->myNum];
+    if (pPicture->pDrawable)
+    {
+	dmxScreen = &dmxScreens[pPicture->pDrawable->pScreen->myNum];
+	pPictPriv = DMX_GET_PICT_PRIV(pPicture);
+
+	if (pPictPriv->pict)
+	{
+	    char name[256];
+
+	    filter  = (char *)(stuff + 1);
+	    params  = (XFixed *)(filter + ((stuff->nbytes + 3) & ~3));
+	    nparams = ((XFixed *)stuff + client->req_len) - params;
+
+	    strncpy (name, filter, stuff->nbytes);
+	    name[stuff->nbytes] = '\0';
+
+	    XLIB_PROLOGUE (dmxScreen);
+	    XRenderSetPictureFilter(dmxScreen->beDisplay,
+				    pPictPriv->pict,
+				    name,
+				    params,
+				    nparams);
+	    XLIB_EPILOGUE (dmxScreen);
+	}
+    }
+
+    return dmxSaveRenderVector[stuff->renderReqType](client);
+}
+
+static int dmxProcRenderChangePicture(ClientPtr client)
+{
+    int ret;
+    REQUEST(xRenderChangePictureReq);
+
+    ret = dmxSaveRenderVector[stuff->renderReqType](client);
+
+    if (ret == Success && (stuff->mask & CPRepeat)) {
+	PicturePtr     pPicture;
+	dmxPictPrivPtr pPictPriv;
+	int            i;
+
+	pPicture = SecurityLookupIDByType(client, stuff->picture, PictureType,
+					  DixDestroyAccess);
+	pPictPriv = DMX_GET_PICT_PRIV(pPicture);
+	if (pPictPriv->sourcePict)
+	{
+	    XRenderPictureAttributes attribs;
+
+	    attribs.repeat = pPicture->repeatType;
+
+	    for (i = 0; i < dmxNumScreens; i++) {
+		DMXScreenInfo *dmxScreen = &dmxScreens[i];
+
+		if (pPictPriv->sourcePict[i])
+		{
+		    XLIB_PROLOGUE (dmxScreen);
+		    XRenderChangePicture(dmxScreen->beDisplay,
+					 pPictPriv->sourcePict[i],
+					 CPRepeat, &attribs);
+		    XLIB_EPILOGUE (dmxScreen);
+		}
+	    }
+	}
+    }
+
+    return ret;
+}
+
+static int
+dmxGetSourceStops (SourcePictPtr pSourcePict,
+		   XFixed **stops,
+		   XRenderColor **colors)
+{
+    if (pSourcePict->gradient.nstops)
+    {
+	int i;
+
+	*stops = xalloc (pSourcePict->gradient.nstops * sizeof (XFixed));
+	*colors = xalloc (pSourcePict->gradient.nstops *
+			  sizeof (XRenderColor));
+
+	for (i = 0; i < pSourcePict->gradient.nstops; i++)
+	{
+	    (*stops)[i]  = pSourcePict->gradient.stops[i].x;
+	    (*colors)[i].red = pSourcePict->gradient.stops[i].color.red;
+	    (*colors)[i].green = pSourcePict->gradient.stops[i].color.green;
+	    (*colors)[i].blue = pSourcePict->gradient.stops[i].color.blue;
+	    (*colors)[i].alpha = pSourcePict->gradient.stops[i].color.alpha;
+	}
+    }
+    else
+    {
+	*stops = NULL;
+	*colors = NULL;
+    }
+
+    return pSourcePict->gradient.nstops;
+}
+
+static Picture
+dmxDoCreateSourcePicture (int idx, PicturePtr pPicture)
+{
+    DMXScreenInfo *dmxScreen = &dmxScreens[idx];
+    Picture       pict = None;
+
+    if (pPicture->pSourcePict)
+    {
+	SourcePictPtr pSourcePict = pPicture->pSourcePict;
+	XFixed *stops = NULL;
+	XRenderColor *colors = NULL;
+	int nstops = 0;
+
+	if (!dmxScreen->beDisplay)
+	    return 0;
+
+	switch (pSourcePict->type) {
+	case SourcePictTypeSolidFill: {
+	    XRenderColor c;
+
+	    c.alpha = (pSourcePict->solidFill.color & 0xff000000) >> 16;
+	    c.red   = (pSourcePict->solidFill.color & 0x00ff0000) >> 8;
+	    c.green = (pSourcePict->solidFill.color & 0x0000ff00) >> 0;
+	    c.blue  = (pSourcePict->solidFill.color & 0x000000ff) << 8;
+
+	    XLIB_PROLOGUE (dmxScreen);
+	    pict = XRenderCreateSolidFill (dmxScreen->beDisplay, &c);
+	    XLIB_EPILOGUE (dmxScreen);
+	} break;
+	case SourcePictTypeLinear: {
+	    XLinearGradient l;
+
+	    l.p1.x = pSourcePict->linear.p1.x;
+	    l.p1.y = pSourcePict->linear.p1.y;
+	    l.p2.x = pSourcePict->linear.p2.x;
+	    l.p2.y = pSourcePict->linear.p2.y;
+
+	    nstops = dmxGetSourceStops (pSourcePict, &stops, &colors);
+
+	    XLIB_PROLOGUE (dmxScreen);
+	    pict = XRenderCreateLinearGradient (dmxScreen->beDisplay, &l,
+						stops, colors, nstops);
+	    XLIB_EPILOGUE (dmxScreen);
+	} break;
+	case SourcePictTypeRadial: {
+	    XRadialGradient r;
+
+	    r.inner.x = pSourcePict->radial.c1.x;
+	    r.inner.y = pSourcePict->radial.c1.y;
+	    r.inner.radius = pSourcePict->radial.c1.radius;
+	    r.outer.x = pSourcePict->radial.c2.x;
+	    r.outer.y = pSourcePict->radial.c2.y;
+	    r.outer.radius = pSourcePict->radial.c2.radius;
+
+	    nstops = dmxGetSourceStops (pSourcePict, &stops, &colors);
+
+	    XLIB_PROLOGUE (dmxScreen);
+	    pict = XRenderCreateRadialGradient (dmxScreen->beDisplay, &r,
+						stops, colors, nstops);
+	    XLIB_EPILOGUE (dmxScreen);
+	} break;
+	case SourcePictTypeConical: {
+	    XConicalGradient c;
+
+	    c.center.x = pSourcePict->conical.center.x;
+	    c.center.y = pSourcePict->conical.center.y;
+	    c.angle = pSourcePict->conical.angle;
+
+	    nstops = dmxGetSourceStops (pSourcePict, &stops, &colors);
+
+	    XLIB_PROLOGUE (dmxScreen);
+	    pict = XRenderCreateConicalGradient (dmxScreen->beDisplay, &c,
+						 stops, colors, nstops);
+	    XLIB_EPILOGUE (dmxScreen);
+	} break;
+	}
+
+	if (nstops)
+	{
+	    xfree (stops);
+	    xfree (colors);
+	}
+    }
+
+    return pict;
+}
+
+static int dmxCreateSourcePicture(ClientPtr client, XID pid)
+{
+    PicturePtr     pPicture;
+    dmxPictPrivPtr pPictPriv;
+    int            i;
+
+    pPicture = SecurityLookupIDByType(client, pid, PictureType,
+				      DixDestroyAccess);
     pPictPriv = DMX_GET_PICT_PRIV(pPicture);
+    MAXSCREENSALLOC_RETURN(pPictPriv->sourcePict, BadAlloc);
+    memset (pPictPriv->sourcePict, 0,
+	    sizeof (*pPictPriv->sourcePict) * MAXSCREENS);
+    pPictPriv->pict = (Picture) 0;
+    AddResource (pid, DMX_SOURCEPICT, pPicture);
+    pPicture->refcnt++;
 
-    if (pPictPriv->pict) {
-	filter  = (char *)(stuff + 1);
-	params  = (XFixed *)(filter + ((stuff->nbytes + 3) & ~3));
-	nparams = ((XFixed *)stuff + client->req_len) - params;
-
-	XRenderSetPictureFilter(dmxScreen->beDisplay,
-				pPictPriv->pict,
-				filter,
-				params,
-				nparams);
-	dmxSync(dmxScreen, FALSE);
+    for (i = 0; i < dmxNumScreens; i++) {
+	DMXScreenInfo *dmxScreen = &dmxScreens[i];
+
+	if (!dmxScreen->beDisplay)
+	    continue;
+
+	pPictPriv->sourcePict[i] = dmxDoCreateSourcePicture (i, pPicture);
     }
 
-    return dmxSaveRenderVector[stuff->renderReqType](client);
+    return Success;
+}
+
+static int dmxProcRenderCreateSolidFill (ClientPtr client)
+{
+    int ret;
+    REQUEST(xRenderCreateSolidFillReq);
+
+    ret = dmxSaveRenderVector[stuff->renderReqType](client);
+    if (ret != Success)
+	return ret;
+
+    return dmxCreateSourcePicture (client, stuff->pid);
 }
 
+static int dmxProcRenderCreateLinearGradient (ClientPtr client)
+{
+    int ret;
+    REQUEST(xRenderCreateLinearGradientReq);
+
+    ret = dmxSaveRenderVector[stuff->renderReqType](client);
+    if (ret != Success)
+	return ret;
+
+    return dmxCreateSourcePicture (client, stuff->pid);
+}
+
+static int dmxProcRenderCreateRadialGradient (ClientPtr client)
+{
+    int ret;
+    REQUEST(xRenderCreateRadialGradientReq);
+
+    ret = dmxSaveRenderVector[stuff->renderReqType](client);
+    if (ret != Success)
+	return ret;
+
+    return dmxCreateSourcePicture (client, stuff->pid);
+}
+
+static int dmxProcRenderCreateConicalGradient (ClientPtr client)
+{
+    int ret;
+    REQUEST(xRenderCreateConicalGradientReq);
+
+    ret = dmxSaveRenderVector[stuff->renderReqType](client);
+    if (ret != Success)
+	return ret;
+
+    return dmxCreateSourcePicture (client, stuff->pid);
+}
 
 /** Create a picture on the appropriate screen.  This is the actual
  *  function that creates the picture.  However, if the associated
